WAComponent subclass: #MDcardapioEpedido
	instanceVariableNames: 'caixa perso valor nome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete-FrontEnd'!

!MDcardapioEpedido methodsFor: 'as yet unclassified' stamp: 'm 6/10/2007 12:26'!
caixa: umaCaixa.
	caixa:= umaCaixa.
! !

!MDcardapioEpedido methodsFor: 'as yet unclassified' stamp: 'm 6/10/2007 21:19'!
pagar: umPedido on: html
	umPedido getNumPedidos = 0 ifFalse:
[	
	html form: [
		html submitButton callback: [ self answer: true ]; text: 'Pagar'.
	]
].! !

!MDcardapioEpedido methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 20:34'!
renderContentOn: html
	| cardapio pedido |

	cardapio := caixa getCardapio.
	pedido    := caixa getPedido.	
	cardapio renderContentOn: html pedido: pedido.
	html horizontalRule.
	pedido renderPedidoEm: html.
	self pagar: pedido on: html.
	html form: [html submitButton text: 'Personalizar prato';
		callback: [ perso ifTrue: [self setOff]
			ifFalse: [self setOn].	].
		
	].
	perso ifTrue: [
		html break.
		html form: [
			html text: 'Nome do Ingrediente: '.
			html textInput
				size: 20;
				exampleText: 'Insira o nome do ingrediente aqui';
				callback: [ :n | nome := n ].
			html text: ' Maximo de calorias no prato: '.
			html textInput
				value: valor;
				size: 5;
				callback: [ :v | valor := v ].
			html break.
			html submitButton text: 'Adicionar';
				callback: [ cardapio adicionaPersonal: nome limite: valor].
		].
	].! !

!MDcardapioEpedido methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 18:58'!
setOff

	perso := false.! !

!MDcardapioEpedido methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 18:58'!
setOn

	perso := true.! !


WAComponent subclass: #MDpagamento
	instanceVariableNames: 'caixa valorPago status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete-FrontEnd'!

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 18:03'!
initialize	
	caixa := Caixa getCaixa.
	status := 0.
! !

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'SGG 6/12/2007 23:02'!
insuficienteOn: html
"	caixa:= Caixa getCaixa."
	html text:  'Voce nao tem dinheiro suficiente!!'.
	html break.
	html text:  'Valor pago = '.
	html text: valorPago.
	html break.
	html text:  'Valor total do pedido = '.
	html text: caixa totalDoPedido.
	html break.
	html text:  'Valor restante = '.
	html text: caixa totalDoPedido - valorPago.
	html form: [ html submitButton text: 'Voltar';
		callback: [status := 0].
	].
! !

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'm 6/10/2007 22:30'!
recebeDinheiro: valor

		valorPago:= valor.
! !

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 17:35'!
renderContentOn: html
	status = 0 
		ifTrue: [self renderPagamentoOn: html.]
		ifFalse: [
				status = 1
					ifTrue: [self insuficienteOn: html.]
					ifFalse: [self suficienteOn: html.].
				].
! !

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 17:31'!
renderPagamentoOn: html
"	caixa:= Caixa getCaixa."
	| troco |
	html text: 'Valor da sua Conta: '.
	html text: caixa totalDoPedido.

	html form: [
		html textInput
			value: valorPago;
			size: 60;
			exampleText: 'Insira o valor pago aqui';

			callback: [ :v | self recebeDinheiro: v.
				
"			troco := caixa fechaPedido: v."
			troco := valorPago - caixa totalDoPedido.
			
			troco < 0
					ifTrue: [status := 1.]
					ifFalse: [status := 2.].
			


			 ].

		html break.
		html submitButton text: 'Pagar'.


	]! !

!MDpagamento methodsFor: 'as yet unclassified' stamp: 'DBP 6/12/2007 17:37'!
suficienteOn: html
"	caixa:= Caixa getCaixa."
	html text:  'Voce pagou '.
	html text: valorPago.
	html break.
	html text:  'O seu troco e de =  '.
	html text: valorPago - (caixa totalDoPedido).
	html break.
	html text: 	'Bom apetite!!'.
	caixa fechaPedido: valorPago.
! !


WAComponent subclass: #MDrestaurant
	instanceVariableNames: 'restaurantTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete-FrontEnd'!
!MDrestaurant commentStamp: '<historical>' prior: 0!
Wrapper do restauranteTask!


!MDrestaurant methodsFor: 'initialization' stamp: 'SGG 6/12/2007 22:52'!
initialize
	super initialize.
	restaurantTask := MDrestaurantTask new. 
 "	meuRestaurantTask := WAStoreTask new. "
	Transcript write: 'MDrestaurant inicializado'; cr.
! !


!MDrestaurant methodsFor: 'skin' stamp: 'm 6/10/2007 12:38'!
children
	^ Array with: restaurantTask! !

!MDrestaurant methodsFor: 'skin' stamp: 'm 6/6/2007 18:22'!
desc
	"Digite a descricao do seu restaurante aqui"

	^ 'Aceitamos tickets Coesas e fechamos em qualquer greve'.! !

!MDrestaurant methodsFor: 'skin' stamp: 'm 6/6/2007 18:21'!
nome
	"Digite o nome do seu restaurante aqui"

	^ 'Restaurantes BandeX'! !

!MDrestaurant methodsFor: 'skin' stamp: 'm 6/10/2007 12:45'!
style
	^ '
body {
	margin: 0px; 
	font-family: sans-serif
}


.TableCardapio {
	background-color: #00aaaa;
	width: 100%;
	border: dotted;
	border-style: ridge;
}

.TablePedido {
	background-color: #aa00aa;
	width: 100%;
	border: dotted;
	border-style: ridge;
}

#banner {
	width: 100%
}	
#banner tr {
	background-color: lightblue;
	text-align: right;
	padding: 10px;
	vertical-align: bottom
}
#title {
	font-size: 18pt;
	font-weight: bold
}
#subtitle {
	font-size: 9pt;
	font-style: italic
}
#body {
	padding: 5px
}
.validation-error {
	color: red;
	font-size: 15pt; 
	padding: 5px
}


	caption {
	font-weight: bold;
	padding: 0.5em 0 1em 0;
}
td, th {
	border: dotted;
	border-style: ridge;
	padding: 3px;
}
'

! !


!MDrestaurant methodsFor: 'render' stamp: 'm 6/10/2007 21:14'!
body: html
	html div id: 'body'; with: restaurantTask.
! !

!MDrestaurant methodsFor: 'render' stamp: 'SGG 6/12/2007 23:23'!
renderContentOn: html
	html table
		id: 'banner';
		with: [
			html tableRow: [
				html tableData: [
					html div id: 'title'; with: self nome.
					html div id: 'subtitle'; with: self desc. ] ] ].
	html div id: 'body'; with: [self body: html].
 ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MDrestaurant class
	instanceVariableNames: ''!

!MDrestaurant class methodsFor: 'as yet unclassified' stamp: 'm 6/6/2007 18:14'!
canBeRoot
	"for Seaside"

	^ true.! !

!MDrestaurant class methodsFor: 'as yet unclassified' stamp: 'm 6/6/2007 18:15'!
description
	^ 'Interface HTML de controle de restaurantes'.! !


WATask subclass: #MDrestaurantTask
	instanceVariableNames: 'caixa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete-FrontEnd'!

!MDrestaurantTask methodsFor: 'as yet unclassified' stamp: 'SGG 6/12/2007 22:52'!
go
	Transcript show: 'Inicializando caixa'; cr.
	caixa := Caixa getCaixa.
	caixa iniciaPedido.
	"caixa pede: 'Beirute'."
		Transcript show: 'MDRT go'; cr.
	self isolate: [  
		self mostraCardapio. 
		].
	self isolate: [
		self iniciaPagamento.
	].

! !

!MDrestaurantTask methodsFor: 'as yet unclassified' stamp: 'm 6/10/2007 21:16'!
iniciaPagamento
	|pagamento| 
	pagamento := MDpagamento new.
	self call: pagamento.! !

!MDrestaurantTask methodsFor: 'as yet unclassified' stamp: 'SGG 6/12/2007 22:51'!
mostraCardapio
	| cardapioEpedido |
	Transcript show: 'mostrandoCardapio'; cr.
	cardapioEpedido := MDcardapioEpedido new.
	cardapioEpedido setOff.
	cardapioEpedido caixa: caixa.
	self call: cardapioEpedido.! !
