﻿Object subclass: #Caixa
	instanceVariableNames: 'cozinheiro cardapio pedido dinheiroColetado'
	classVariableNames: 'CaixaSingleton'
	poolDictionaries: ''
	category: 'Lanchonete'!
!Caixa commentStamp: '<historical>' prior: 0!
Basicamente o cara que faz tudo.!


!Caixa methodsFor: 'Lanchonete' stamp: 'DBP 6/12/2007 20:06'!
fechaPedido: dinheiro
	"recebe dinheiro, se for menor que a conta, reclama. caso contrario manda o prato ser feito e devolve o troco"

	| valorConta  troco |
	valorConta := self totalDoPedido.
	
	valorConta > dinheiro ifTrue: [
		Transcript show: 'Erro. Voce tem que me pagar ' , (valorConta  printString), ' porem so me pagou ' , 
		(dinheiro printString), '. Vou devolver o dinheiro. Me pague direito da proxima vez!!';cr.
		^ dinheiro.
	].
	
	cozinheiro prepara: pedido.
	troco := dinheiro - valorConta.
	dinheiroColetado := dinheiroColetado + valorConta.	
		
	Transcript show: 'Pedido entregue. Troco: ' , ( ( troco) printString ) ;cr.
	self iniciaPedido.
	^ troco.
	! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm 6/10/2007 11:47'!
getCardapio
	"Soma o valor do pedido e apresenta para o cliente"

	^ cardapio.! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:26'!
getDinheiroColetado
	"Mostra quanto o dinheiro o caixa ja coletou"
	^ dinheiroColetado! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm 6/9/2007 17:42'!
getPedido
	"retorna o Pedido"

	^ pedido.! !

!Caixa methodsFor: 'Lanchonete' stamp: 'DBP 6/12/2007 20:10'!
iniciaPedido
	"Inicia um Pedido"

	pedido := Pedido novo.
	dinheiroColetado := 0.
	cardapio setPratoPersonalizado.
	

	Transcript show: 'Caixa: pronto para receber pedidos.' ; cr.! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 19:32'!
mostraPratosDoCardapio
	"Mostra os pratos do cardapio"
	| x | 
	x := cardapio getListaDePratos.
	
	x do:[ :i |
		Transcript show: 'Prato [' , ( i getNome ) , '] Preco: [' , ((i getPreco) printString) ,']' ;  cr.
	].! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:22'!
pede: umNome
	"Adiciona um prato no pedido"
	| umPrato |

	umPrato := (cardapio getPratoFromName: umNome).	

	( umPrato = False ) ifTrue:[
		Transcript show: 'O prato [' , umNome , '] nao pertence ao cardapio, logo nao sera adicionado.' ;cr.
	] ifFalse: [
		pedido adiciona: umPrato.
	].

! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 17:06'!
pratosDoCardapio
	"Mostra os pratos do cardapio"
	^ cardapio getListaDePratos.! !

!Caixa methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:08'!
totalDoPedido
	"Soma o valor do pedido e apresenta para o cliente"

	^ pedido precoTotal.! !


!Caixa methodsFor: 'rendering' stamp: 'm 6/10/2007 12:16'!
mostraCardapioPedido: html
	
	cardapio renderContentOn: html.
	html text: '<hr>'.
	cardapio renderContentOn: html.
"
	pedido renderContentOn: html.
"! !

!Caixa methodsFor: 'rendering' stamp: 'm 6/10/2007 11:50'!
renderContentOn: html
	
	html text: 'ERRO. Tentaram rendereizar a caixa.'.
	html break.! !


!Caixa methodsFor: 'Initialize' stamp: 'm.d. 4/27/2007 18:36'!
allocateCardapio
	"Instancia o cardapio"

	cardapio:= Cardapio novo.! !

!Caixa methodsFor: 'Initialize' stamp: 'm.d. 4/27/2007 18:36'!
allocateCozinheiro
	"Pega um Cozinheiro para a caixa"

	cozinheiro:= Cozinheiro novoComEstilo: 'Lanchonete'.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Caixa class
	instanceVariableNames: ''!

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 20:51'!
testCaixaInit
	"TESTE: Intanciando o Caixa"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Intanciando o Caixa';cr.
	CaixaSingleton := nil.
	Caixa getCaixa.! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 21:08'!
testMe
	"Testa o Caixa"

	self	testCaixaInit.
	self testMostraPratos.
	self testPedeCoisasExistentes.
	self testPedeCoisasEsquisitas.
	self testVerificaPrecoTotal.
	self testTentandoPagarMenos.
	self testTentandoPagarMais.
	self testVerificaPrecoTotal.

	Transcript show: '';cr.	
	Transcript show: 'TESTE: todos os testes foram realizados !!!!!!';cr.
	Transcript show: '';cr.	
! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 20:55'!
testMostraPratos
	"TESTE: Listando os pratos do cardapio"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Listando os pratos do cardapio';cr.
	CaixaSingleton mostraPratosDoCardapio.! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 21:00'!
testPedeCoisasEsquisitas
	"TESTE: Pedindo algo que nao esta no cardapio"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Pedindo algo que nao esta no cardapio';cr.
	CaixaSingleton pede: 'Suco de Banana'.
! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 20:56'!
testPedeCoisasExistentes
	"TESTE: Pedindo um Beirute e um Suco de Laranja"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Pedindo um Beirute e um Suco de Laranja';cr.
	
	CaixaSingleton pede: 'Suco de Laranja'.
	CaixaSingleton pede: 'Beirute'.! !

!Caixa class methodsFor: 'testing' stamp: 'm 6/8/2007 14:31'!
testTentandoPagarMais
	"TESTE: Tentanto pagar mais do que deveria"
	Transcript show: '';cr.
	Transcript show: 'TESTE: Tentanto pagar mais do que deveria [100,00]';cr.
	CaixaSingleton fechaPedido: 100.
! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 21:07'!
testTentandoPagarMenos
	"TESTE: Tentanto pagar menos do que deveria"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Tentanto pagar menos do que deveria';cr.
	CaixaSingleton fechaPedido: 10.
! !

!Caixa class methodsFor: 'testing' stamp: 'm.d. 4/27/2007 21:02'!
testVerificaPrecoTotal
	"TESTE: Verificando o preco do pedido"

	Transcript show: '';cr.
	Transcript show: 'TESTE: Verificando o preco do pedido';cr.
	CaixaSingleton totalDoPedido.
	Transcript show: 'Total do Pedido: [' , (( CaixaSingleton totalDoPedido )  printString )  , ']';cr.
! !


!Caixa class methodsFor: 'class initialization' stamp: 'DBP 6/12/2007 20:23'!
getCaixa
	"instancia/retorna meu singleton"
	
CaixaSingleton = nil
	ifTrue: [
	CaixaSingleton := Caixa new.
	CaixaSingleton allocateCardapio.
	CaixaSingleton allocateCozinheiro.
"	CaixaSingleton iniciaPedido."

	Transcript show: 'Caixa inicializado '; cr.
	]
	ifFalse: [ 
	Transcript show: 'Retornando instancia do caixa';cr.
	].
^ CaixaSingleton! !


!Caixa class methodsFor: 'private' stamp: 'm.d. 4/27/2007 21:11'!
authors
	"Autores do EP"

	Transcript show: 'Marcos Diez   4963284' ;cr.
	Transcript show: 'Samuel Gales Guimaraes' ;cr.
	Transcript show: 'Daniel Bento de Paula' ;cr.
! !

!Caixa class methodsFor: 'private' stamp: 'DBP 6/12/2007 17:53'!
reset
	CaixaSingleton := nil.! !


Object subclass: #Cardapio
	instanceVariableNames: 'listaDePratos listaDeIngredientes precoExtra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Cardapio commentStamp: '<historical>' prior: 0!
Uma lista de pratos com operacoes simples ( por, tirar, etc..)!


!Cardapio methodsFor: 'Initialize' stamp: 'SGG 6/6/2007 19:45'!
apagaIngredientes
	"apaga os ingredientes do cardapio"

	listaDeIngredientes := Bag new.! !

!Cardapio methodsFor: 'Initialize' stamp: 'm.d. 4/23/2007 16:55'!
apagaTodosOsPratos
	"zera o cardapio"

	listaDePratos:= Bag new.! !

!Cardapio methodsFor: 'Initialize' stamp: 'DBP 6/12/2007 20:29'!
popula
	"Popula o Cardapio"

	| umPrato lista |.
	

	self adicionaIngrediente: (Ingrediente novo: 'pao' custa: 0.5 leva: 0.1 engorda: 100).
	self adicionaIngrediente: (Ingrediente novo: 'carne' custa: 2 leva: 5 engorda: 120).
	self adicionaIngrediente: (Ingrediente novo: 'queijo' custa: 0.8 leva: 0.2 engorda: 80).
	self adicionaIngrediente: (Ingrediente novo: 'alface' custa: 0.5 leva: 0.1 engorda: 20).
	self adicionaIngrediente: (Ingrediente novo: 'tomate' custa: 0.8 leva: 0.5 engorda: 30).
	self adicionaIngrediente: (Ingrediente novo: 'azeite' custa: 0.5 leva: 0.1 engorda: 50).
	self adicionaIngrediente: (Ingrediente novo: 'palmito' custa: 0.99 leva: 0.2 engorda: 40).
	self adicionaIngrediente: (Ingrediente novo: 'presunto' custa: 0.5 leva: 0.3 engorda: 60).
	self adicionaIngrediente: (Ingrediente novo: 'ovo' custa: 0.75 leva: 2 engorda: 100).
	self adicionaIngrediente: (Ingrediente novo: 'maionese' custa: 0.5 leva: 0.5 engorda: 100).
	self adicionaIngrediente: (Ingrediente novo: 'bacon' custa: 1 leva: 3 engorda: 200).
	self adicionaIngrediente: (Ingrediente novo: 'laranja' custa: 1 leva: 3 engorda: 50).
	self adicionaIngrediente: (Ingrediente novo: 'gelo' custa: 0.5 leva: 0.2 engorda: 0).
	


	lista := Bag new.
	lista add: (self getIngrediente: 'pao').
	lista add: (self getIngrediente: 'carne').
	lista add: (self getIngrediente: 'queijo').

	self adiciona: (Prato novo: 'XBurger' comPreco: 4 feitoDe: lista leva: 3 engorda: 200).


	lista := Bag new.
	lista add: (self getIngrediente: 'alface').
	lista add: (self getIngrediente: 'tomate').
	lista add: (self getIngrediente: 'azeite').	
	
	umPrato := Prato novo: 'Salada' comPreco: 3 feitoDe: lista leva: 2 engorda: 50.
	self adiciona: umPrato.


	lista := Bag new.
	lista add: (self getIngrediente: 'alface').
	lista add: (self getIngrediente: 'palmito').
	lista add: (self getIngrediente: 'azeite').	

	
	umPrato := Prato novo: 'Salada 2' comPreco: 5 feitoDe: lista leva: 2 engorda: 50.
	self adiciona: umPrato.


	lista := Bag new.
	lista add: (self getIngrediente: 'pao').
	lista add: (self getIngrediente: 'carne').
	lista add: (self getIngrediente: 'queijo').	
	lista add: (self getIngrediente: 'presunto').
	lista add: (self getIngrediente: 'ovo').
	lista add: (self getIngrediente: 'tomate').	
	lista add: (self getIngrediente: 'alface').
	lista add: (self getIngrediente: 'maionese').
	lista add: (self getIngrediente: 'bacon').	
	umPrato := Prato novo: 'Beirute' comPreco: 10 feitoDe: lista leva: 5 engorda: 200.

	self adiciona: umPrato.

	lista := Bag new.
	lista add: (self getIngrediente: 'laranja').
	lista add: (self getIngrediente: 'gelo').

	umPrato := Prato novo: 'Suco de Laranja' comPreco: 1 feitoDe: lista leva: 2 engorda: 50.
"	umPrato addIngrediente: (self getIngrediente: 'bacon')."
	self adiciona: umPrato.

	self adiciona: (Prato novo: 'Prato personalizado' comPreco: 2 feitoDe: (Bag new) leva: 0 engorda: 0).
! !

!Cardapio methodsFor: 'Initialize' stamp: 'DBP 6/12/2007 20:28'!
setPratoPersonalizado
	"ajusta o prato personalizado para ser vazio outra vez"

	| aBag pers |.
	"(self getPratoFromName: 'Prato personalizado') = nil
		ifTrue: [self remove: (self getPratoFromName: 'Prato personalizado').]."
	aBag := Bag new.
	pers := self getPratoFromName: 'Prato personalizado'.
	pers setIngredientes: aBag.
	pers setPreco: 0.
	pers setTempo: 0.
	pers setCalorias: 0.
"	self adiciona: (Prato novo: 'Prato personalizado' comPreco: 2 feitoDe: aBag leva: 0 engorda: 0)."! !

!Cardapio methodsFor: 'Initialize' stamp: 'SGG 6/6/2007 19:47'!
setPrecoExtra: preco
	"ajusta o preco de um item fora do cardapio"

	precoExtra := preco.! !


!Cardapio methodsFor: 'Lanchonete' stamp: 'SGG 6/6/2007 19:25'!
adicionaIngrediente: umIngrediente
	"cria um novo ingrediente e guarda"

	listaDeIngredientes add: umIngrediente.
! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'DBP 6/12/2007 20:32'!
adicionaPersonal: umIngrediente limite: nCalor
	"Adiciona um ingrediente ao prato personalizado tomando cuidado para nao passar do limite de calorias"

	| personal ing |.
	personal := self getPratoFromName: 'Prato personalizado'.
	ing := self getIngrediente: umIngrediente.
	nCalor = 0 ifTrue: [personal addIngrediente: ing. Transcript show: 'Calorias ilimitadas!!!!!! Weeeeeeee!!!!'; cr]
		ifFalse: [((personal getCalorias) + (ing getCalorias) <= nCalor) ifTrue: [
				personal addIngrediente: ing.
			]
			ifFalse: [Transcript show: 'Valor de calorias acima do limite!! ('; show: personal getCalorias; show: ')'; cr
			].
		].! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'm.d. 4/23/2007 17:02'!
adiciona: prato
	"Adiciona um prato ao cardapio"

	listaDePratos add: prato! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:02'!
existe: nomeDoPrato
	"Returna True ou False case o prato exista"

	listaDePratos do:[ :estePrato |
		( ( estePrato getNome )= nomeDoPrato ) ifTrue:[ ^ True. ].
	].
	^ False.
! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'SGG 6/6/2007 19:50'!
getIngrediente: nomeDoIngrediente
	"retorna a lista de ingrediente"

	| i |.
	listaDeIngredientes do:[ :esteIngrediente |
		( ( esteIngrediente getNome )= nomeDoIngrediente ) ifTrue:[ ^ esteIngrediente. ].
	].
	i := Ingrediente novo: nomeDoIngrediente custa: precoExtra.
	Transcript show: 'Ingrediente '.
	Transcript show: nomeDoIngrediente.
	Transcript show: ' não consta no cardápio, adicionando com o custo de adicional: '.
	Transcript show: precoExtra.
	Transcript cr.
	^ i.
! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 17:06'!
getListaDePratos
	"Devolve a lista de pratos"

	^ listaDePratos.! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'SGG 6/12/2007 16:56'!
getListaDePratosFiltroTipo: tipoFiltro simNao: SN opcao: objeto
	"Devolve a lista de pratos"

	| lista |.

	lista := Bag new.
	
	(tipoFiltro = 'preco') ifTrue:[
		listaDePratos do: [:prato |
				(SN = '<=') ifTrue:[
					(prato getPreco <= objeto) ifTrue:[
						lista add: prato.
					].
				].
				(SN = '>=') ifTrue:[
					(prato getPreco >= objeto) ifTrue:[
						lista add: prato.
					].
				].
			].
		^ lista.
		].
	(tipoFiltro = 'ingrediente') ifTrue:[
		listaDePratos do: [:prato |
				(SN = 'T') ifTrue:[
					(prato tem: objeto) ifTrue:[
						lista add: prato.
					].
				].
				(SN = 'F') ifTrue:[
					(prato tem: objeto) ifFalse:[
						lista add: prato.
					].
				].
			].
		^ lista.
		].
	(tipoFiltro = 'tempo') ifTrue:[
		listaDePratos do: [:prato |
				(SN = '<=') ifTrue:[
					(prato getTempo <= objeto) ifTrue:[
						lista add: prato.
					].
				].
				(SN = '>=') ifTrue:[
					(prato getNome >= objeto) ifFalse:[
						lista add: prato.
					].
				].
			].
		^ lista.
		].
	
	^ listaDePratos.! !

!Cardapio methodsFor: 'Lanchonete' stamp: 'DBP 6/12/2007 20:14'!
remove: prato
	"Lista de Pratos"

	Transcript show: 'Removido!!!!!!', prato getNome.
	listaDePratos remove: prato ifAbsent: false.
! !


!Cardapio methodsFor: 'private' stamp: 'm.d. 4/27/2007 20:18'!
getPratoFromName: nomeDoPrato
	"Devolve o Prato apartir do nome do Mesmo"

	listaDePratos do:[ :estePrato |
		( ( estePrato getNome )= nomeDoPrato ) ifTrue:[ ^ estePrato. ].
	].
	^ False.! !


!Cardapio methodsFor: 'debugging' stamp: 'SGG 6/12/2007 15:27'!
listaPratos
	"Lista os Pratos"
	
	listaDePratos do:[ :i |
		Transcript show: ( i getNome ); cr.
	].
! !

!Cardapio methodsFor: 'debugging' stamp: 'SGG 6/12/2007 15:27'!
listaPratos: filtro simNao: SN opcao: objeto
	"Lista os Pratos"
	| lista |.

	lista := self getListaDePratosFiltroTipo: filtro simNao: SN opcao: objeto.
	lista do:[ :i |
		Transcript show: ( i getNome ); cr.
	].
! !


!Cardapio methodsFor: 'rendering' stamp: 'DBP 6/12/2007 18:12'!
renderContentOn: html

	| lista |.

	html table
		class: 'TableCardapio';
		border: 0;
		with: [
		html tableHeading: 'Prato'.
		html tableHeading: 'Preco'.
		html tableHeading: 'Calorias'.
		html tableHeading: 'Tempo'.
		html tableHeading: 'Ingredientes'.
		lista := self getListaDePratos.
		lista do:[ :umPrato |
			umPrato drawWithHml: html.
		].
	].! !

!Cardapio methodsFor: 'rendering' stamp: 'DBP 6/12/2007 18:12'!
renderContentOn: html pedido: umPedido

	html table
		class: 'TableCardapio';
		border: 0;
		with: [
		html tableHeading: 'Prato'.
		html tableHeading: 'Preco'.
		html tableHeading: 'Calorias'.
		html tableHeading: 'Tempo'.
		html tableHeading: 'Ingredientes'.
		listaDePratos do:[ :umPrato |
			umPedido renderPrato: umPrato acao: 'adiciona' on:html.
		].
	].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cardapio class
	instanceVariableNames: ''!

!Cardapio class methodsFor: 'class initialization' stamp: 'SGG 6/12/2007 15:30'!
novo
	"gera um novo cardapio"

	| c |
	c := Cardapio new.
	c apagaTodosOsPratos.
	c apagaIngredientes.
	c setPrecoExtra: 2.
	c popula.
	Transcript show: 'Cardapio inicializado' ; cr.
	"c listaPratos.
	Transcript cr.
	c listaPratos: 'preco' simNao: '<=' opcao: 10."
	^ c.! !


Object subclass: #Cozinheiro
	instanceVariableNames: 'meuRobo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Cozinheiro commentStamp: '<historical>' prior: 0!
Recebe pratos e os ingredientes dos mesmos para o Robo!


!Cozinheiro methodsFor: 'Initialize' stamp: 'm.d. 4/27/2007 20:38'!
allocateRobo:    estilo
	"aloca um novoRobo com o estilo estilo"
	meuRobo:= Robo novoComEstilo: estilo.
	^meuRobo! !

!Cozinheiro methodsFor: 'Initialize' stamp: 'm.d. 4/27/2007 20:34'!
getRobo:    estilo
	"aloca um novoRobo com o estilo estilo"
	| r |
	r:= Robo novoComEstilo: estilo.
	^r! !


!Cozinheiro methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:42'!
prepara: umPedido
	"manda os ingredientes do pratos do pedido para o Robo"

	| listaDePratos |
	Transcript show: 'Cozinheiro: Preparando o pedido';cr.
	
	listaDePratos := umPedido getListaDePratos.

	listaDePratos do:[ :umPrato |
		self cozinha: umPrato.
	].
	Transcript show: 'Cozinheiro: Prato preparado';cr.! !


!Cozinheiro methodsFor: 'private' stamp: 'SGG 6/7/2007 01:04'!
cozinha: umPrato
	"cozinha um Prato"

	| meusIngredientes |
	Transcript show: ' preparando o prato ' , ( umPrato getNome ) ;cr.
	meusIngredientes := umPrato getIngredientes.
	
	meusIngredientes do:[ :umIngrediente |
		meuRobo prepara: umIngrediente getNome.
	].
	meuRobo juntaPrato.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cozinheiro class
	instanceVariableNames: ''!

!Cozinheiro class methodsFor: 'class initialization' stamp: 'm.d. 4/27/2007 18:38'!
novoComEstilo: umEstilo
	"cria um novo cozinheiro, que na verdade eh um operador de robo"
	|c|
	c := Cozinheiro new.
	c allocateRobo: umEstilo.
	Transcript show: 'Cozinheiro inicializado com estilo [' , umEstilo , ']' ; cr.
	^c! !


Object subclass: #Ingrediente
	instanceVariableNames: 'nome preco tempo calor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Ingrediente commentStamp: '<historical>' prior: 0!
Classe dos ingredientes!


!Ingrediente methodsFor: 'initialize' stamp: 'SGG 6/12/2007 16:07'!
setCalorias: umTanto
	"Define o numero de calorias"

	calor := umTanto.! !

!Ingrediente methodsFor: 'initialize' stamp: 'SGG 6/6/2007 19:50'!
setNome: umNome
	"seta o nome"

	nome := umNome.! !

!Ingrediente methodsFor: 'initialize' stamp: 'SGG 6/6/2007 19:09'!
setPreco: umPreco
	"seta o preco"

	preco := umPreco.! !

!Ingrediente methodsFor: 'initialize' stamp: 'SGG 6/12/2007 15:33'!
setTempo: umTempo
	"define o tempo de preparo"

	tempo := umTempo.! !


!Ingrediente methodsFor: 'rendering' stamp: 'm 6/10/2007 12:02'!
drawNoPriceWithHtml: html

	html text: self getNome.
	html space.	! !


!Ingrediente methodsFor: 'Acesso' stamp: 'DBP 6/12/2007 18:50'!
drawWithHml: html
	
		html tableRow: [
			html tableData: self getNome.
			html tableData: self getPreco.
			html tableData: self getCalorias.
			html tableData: self getPreco.

"
				html text: self getIngredientes.
				self drawIngredientesSemPreco: self getIngredientes.
"
			].

! !

!Ingrediente methodsFor: 'Acesso' stamp: 'SGG 6/12/2007 15:59'!
getCalorias
	"Retorna o numero de calorias do ingrediente"

	^ calor.! !

!Ingrediente methodsFor: 'Acesso' stamp: 'SGG 6/6/2007 19:30'!
getNome
	"retorna o nome"

	^nome.! !

!Ingrediente methodsFor: 'Acesso' stamp: 'SGG 6/6/2007 19:30'!
getPreco
	"retorna o preco"

	^preco.! !

!Ingrediente methodsFor: 'Acesso' stamp: 'SGG 6/12/2007 15:59'!
getTempo
	"retorna o tempo de preparo do ingrediente"

	^ tempo.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ingrediente class
	instanceVariableNames: ''!

!Ingrediente class methodsFor: 'class initialization' stamp: 'SGG 6/12/2007 15:35'!
novo: umNome custa: umPreco
	"inicializa um novo ingrediente com um nome e preco"

	| i |.
	i := Ingrediente new.
	i setNome: umNome.
	i setPreco: umPreco.
	i setCalorias: 200.
	i setTempo: 2.

	^i.! !

!Ingrediente class methodsFor: 'class initialization' stamp: 'SGG 6/12/2007 15:34'!
novo: umNome custa: umPreco leva: umTempo engorda: umTanto
	"inicializa um novo ingrediente com um nome e preco"

	| i |.
	i := Ingrediente new.
	i setNome: umNome.
	i setPreco: umPreco.
	i setCalorias: umTanto.
	i setTempo: umTempo.
	

	^i.! !


Object subclass: #Pedido
	instanceVariableNames: 'listaDePratos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Pedido commentStamp: '<historical>' prior: 0!
Uma colecao de pratos!


!Pedido methodsFor: 'Initialize' stamp: 'm.d. 4/23/2007 17:07'!
apagaTodosOsPratos
	"zera os pedidos"

	listaDePratos:= Bag new.! !


!Pedido methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:23'!
adiciona: umPrato
	"Adiciona um prato ao cardapio"
	
	Transcript show: 'Voce pediu ' , ( umPrato getNome) ;cr.
	listaDePratos add: umPrato.
! !

!Pedido methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 18:41'!
getListaDePratos
	"devolve a lista de prato"

     ^ listaDePratos.! !

!Pedido methodsFor: 'Lanchonete' stamp: 'm 6/10/2007 20:18'!
getNumPedidos
	"Devolve a quantida de itens pedidos"
	^ listaDePratos size.! !

!Pedido methodsFor: 'Lanchonete' stamp: 'm.d. 4/27/2007 20:25'!
precoTotal
	"Devolve o preco total do pedido"
	
   | precoTotal |
	precoTotal := 0.
	
	listaDePratos do:[ :umPrato |
		precoTotal := (precoTotal +  ( umPrato getPreco )).
	].
	^ precoTotal.! !

!Pedido methodsFor: 'Lanchonete' stamp: 'm.d. 4/23/2007 17:06'!
remove: prato
	"Lista de Pratos"

	listaDePratos remove: prato ifAbsent: false.
! !


!Pedido methodsFor: 'debugging' stamp: 'm.d. 4/23/2007 17:31'!
listaPratos
	"Lista os Pratos"
	
	listaDePratos do:[ :i |
		Transcript show: ( i ); cr.
	].

! !


!Pedido methodsFor: 'rendering' stamp: 'm 6/10/2007 19:19'!
renderContentOn: html

	self renderPedidoEm: html.
	self renderPrecoEm: html! !

!Pedido methodsFor: 'rendering' stamp: 'DBP 6/12/2007 18:07'!
renderPedidoEm: html
	
	self getNumPedidos = 0 ifFalse: [
		html table
			class: 'TablePedido';
			border: 0;
			with: [
			html tableHeading: 'Prato'.
			html tableHeading: 'Preco'.
			html tableHeading: 'Calorias'.
			html tableHeading: 'Tempo'.
			html tableHeading: 'Ingredientes'.
			listaDePratos do:[ :umPrato |
				self renderPrato: umPrato acao:'remove' on:html.
				].
		].
	].! !

!Pedido methodsFor: 'rendering' stamp: 'DBP 6/12/2007 18:13'!
renderPrato: umPrato acao:umaAcao on: html 

	
	html tableRow: [
		html tableData: [
			html anchor callback: [
				umaAcao = 'adiciona' 
					ifTrue: [ self adiciona: umPrato  ]
					ifFalse: [ self remove:  umPrato ]. 
			]; with: umPrato getNome.
		].
		html tableData: umPrato getPreco.
		html tableData: umPrato getCalorias.
		html tableData: umPrato getTempo.

		html tableData: [
		umPrato getIngredientes do:[ :umIngrediente |
				umIngrediente drawNoPriceWithHtml: html.
			].
		].
	].	
"
		 Nothing more expected ->class: 'TablePedido';
		border: 0;
		with: [
		html tableHeading: 'Prato'.
		html tableHeading: 'Preco'.
		html tableHeading: 'Ingredientes'.
		listaDePratos do:[ :umPrato2 |
			umPrato drawWithHml: html.
		].
	].
"! !

!Pedido methodsFor: 'rendering' stamp: 'm 6/10/2007 19:18'!
renderPrecoEm: html
	html text: 'Preco: '.
	html text: self precoTotal.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Pedido class
	instanceVariableNames: ''!

!Pedido class methodsFor: 'class initialization' stamp: 'm.d. 4/27/2007 18:29'!
novo
	"gera um novo pedido"

	| c |
	c:= Pedido new.
	c apagaTodosOsPratos.
	Transcript show: 'Pedido inicializado';cr.
	^ c.! !


Object subclass: #Prato
	instanceVariableNames: 'nome ingredientes preco tempo calor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Prato commentStamp: '<historical>' prior: 0!
A composicao de cada praco, assim como seu nome e preco!


!Prato methodsFor: 'Initialize' stamp: 'SGG 6/12/2007 17:34'!
addCaloria: adicional
	"adiciona uma quantia ao preco"

	calor := calor + adicional.! !

!Prato methodsFor: 'Initialize' stamp: 'SGG 6/6/2007 20:17'!
addPreco: adicional
	"adiciona uma quantia ao preco"

	preco := preco + adicional.! !

!Prato methodsFor: 'Initialize' stamp: 'SGG 6/12/2007 17:34'!
addTempo: adicional
	"adiciona uma quantia ao preco"

	tempo := tempo + adicional.! !

!Prato methodsFor: 'Initialize' stamp: 'DBP 6/12/2007 18:49'!
renderContentOn: html

	| lista |.

	html table
		class: 'TablePrato';
		border: 0;
		with: [
		html tableHeading: 'Ingrediente'.
		html tableHeading: 'Preco'.
		html tableHeading: 'Calorias'.
		html tableHeading: 'Tempo'.
		lista := self getIngredientes.
		lista do:[ :umIngrediente |
			umIngrediente drawWithHml: html.
		].
	].! !

!Prato methodsFor: 'Initialize' stamp: 'SGG 6/12/2007 16:38'!
setCalorias: umTanto
	"Calcula o numero de calorias do prato"

	| total |.

	total := umTanto.
	ingredientes do: [ :ing |
		total := total + (ing getCalorias).].

	calor := total.

! !

!Prato methodsFor: 'Initialize' stamp: 'm.d. 4/23/2007 16:35'!
setIngredientes: umaLista
	"seta a lista de ingredientes vazia"

	ingredientes := umaLista.! !

!Prato methodsFor: 'Initialize' stamp: 'm.d. 4/23/2007 14:57'!
setNome: umNome
	"define nome do prato"

	nome := umNome.! !

!Prato methodsFor: 'Initialize' stamp: 'SGG 6/12/2007 16:06'!
setPreco: umPreco
	"seta preco do prato"

	| precoCusto |.

	precoCusto := umPreco.
	ingredientes do:[ :esteIngrediente |
		precoCusto := precoCusto + (esteIngrediente getPreco). ].

	preco := precoCusto.

! !

!Prato methodsFor: 'Initialize' stamp: 'SGG 6/12/2007 16:35'!
setTempo: umTempo
	"Determina o tempo de produçao do prato"

	| total |.

	total := umTempo.

	ingredientes do: [ :ing |
		total := total + (ing getTempo).
	].

	tempo := total.! !


!Prato methodsFor: 'Lanchonete' stamp: 'SGG 6/12/2007 17:35'!
addIngrediente: umIngrediente
	"adiciona um ingrediente à gororoba"

	ingredientes add: umIngrediente.
	self addPreco: umIngrediente getPreco.
	self addCaloria: umIngrediente getCalorias.
	self addTempo: umIngrediente getTempo.

	Transcript show: 'Adicionado ', umIngrediente getNome, ' a(o) ', self getNome, '. Novo custo: R$'.
	Transcript show: self getPreco; cr.! !

!Prato methodsFor: 'Lanchonete' stamp: 'SGG 6/12/2007 16:08'!
getCalorias
	"Retorna o numero de calorias do prato"

	^calor.! !

!Prato methodsFor: 'Lanchonete' stamp: 'm.d. 4/23/2007 16:38'!
getIngredientes
	"Retorna uma lista com os ingredientes do prato"

	^ ingredientes.! !

!Prato methodsFor: 'Lanchonete' stamp: 'm.d. 4/23/2007 16:36'!
getNome
	"Retorna o nome do prato"

	^ nome.! !

!Prato methodsFor: 'Lanchonete' stamp: 'm.d. 4/23/2007 16:37'!
getPreco
	"Retorna o preco do prato"
	^ preco.
! !

!Prato methodsFor: 'Lanchonete' stamp: 'SGG 6/12/2007 16:08'!
getTempo
	"retorna o tempo de preparo do prato"
	
	^tempo.! !

!Prato methodsFor: 'Lanchonete' stamp: 'DBP 6/12/2007 18:40'!
renderContentOn: html pedido: umPedido

	html table
		class: 'TableCardapio';
		border: 0;
		with: [
		html tableHeading: 'Prato'.
		html tableHeading: 'Preco'.
		html tableHeading: 'Calorias'.
		html tableHeading: 'Tempo'.
		html tableHeading: 'Ingredientes'.
"		listaDeIngredientes do:[ :umPrato |
			umPedido renderPrato: umPrato acao: 'adiciona' on:html.
		]."
	].! !

!Prato methodsFor: 'Lanchonete' stamp: 'SGG 6/12/2007 16:53'!
tem: esseIngrediente
	"Dis se o prato possui aquele ingrediente ou nao"

	ingredientes do: [ :ing|
		((ing getNome) = esseIngrediente) ifTrue: [^ true].
	].

	^ false.! !


!Prato methodsFor: 'rendering' stamp: 'm 6/10/2007 12:01'!
drawWithHml: html
	
		html tableRow: [
			html tableData: self getNome.
			html tableData: self getPreco.
			html tableData: [
				ingredientes do:[ :umIngrediente |
					umIngrediente drawNoPriceWithHtml: html.
				].
"
				html text: self getIngredientes.
				self drawIngredientesSemPreco: self getIngredientes.
"
			].
		].	
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Prato class
	instanceVariableNames: ''!

!Prato class methodsFor: 'class initialization' stamp: 'SGG 6/12/2007 16:15'!
novo: umNome comPreco: umValor feitoDe:  umaLista
	"inicializa um prato com nome e preco"

	| p |
	p := Prato new.
	p setNome: umNome.
	p setIngredientes: umaLista.
	p setPreco: umValor.
	p setCalorias: 200.
	p setTempo: 2.
	
	Transcript show: 'Prato [' , umNome , ' R$'.
	Transcript show: (p getPreco).
	Transcript show: ' '.
	Transcript show: (p getCalorias).
	Transcript show: ' Calorias e leva '.
	Transcript show: (p getTempo).
	Transcript show: ' minutos] inicializado.';cr.
	^p.! !

!Prato class methodsFor: 'class initialization' stamp: 'SGG 6/12/2007 16:09'!
novo: umNome comPreco: umValor feitoDe:  umaLista leva: umTempo engorda: umTanto
	"inicializa um prato com nome e preco"

	| p |
	p := Prato new.
	p setNome: umNome.
	p setIngredientes: umaLista.
	p setPreco: umValor.
	p setCalorias: umTanto.
	p setTempo: umTempo.
	
	Transcript show: 'Prato [' , umNome , ' R$'.
	Transcript show: (p getPreco).
	Transcript show: ' '.
	Transcript show: (p getCalorias).
	Transcript show: ' Calorias e leva '.
	Transcript show: (p getTempo).
	Transcript show: ' minutos] inicializado.';cr.
	^p.! !


Object subclass: #Robo
	instanceVariableNames: 'estilo ingredientes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lanchonete'!
!Robo commentStamp: '<historical>' prior: 0!
Robo que cozinha tudo para nos	!


!Robo methodsFor: 'Initialize' stamp: 'm.d. 4/27/2007 16:22'!
allocateIngredientes
	"inicialiaza a bag que conterá os ingredientes"

	ingredientes := Bag new.! !

!Robo methodsFor: 'Initialize' stamp: 'SGG 4/19/2007 16:53'!
setEstilo: umEstilo
	"Coloca um estilo no robo"

	estilo := umEstilo.
! !

!Robo methodsFor: 'Initialize' stamp: 'm.d. 4/23/2007 15:33'!
setIngredientes
	"inicialiaza a bag que conterá os igredientes"

	ingredientes := Bag new.! !


!Robo methodsFor: 'Cozinha' stamp: 'm.d. 4/27/2007 18:57'!
juntaPrato
	"junta os ingredientes formando o prato"

"Eu deveria mandar os ingredientes para o Robo, Porem, como no mundo magico do Squeak tudo eh de mentira, vou limpar a bag de ingredientes e pronto"


"TODO: listar o que tinha na bag, so para mostrar servico"
	Transcript show: 'Robo: Preparando o prato...'; cr.
     self setIngredientes.
! !

!Robo methodsFor: 'Cozinha' stamp: 'm.d. 4/27/2007 20:38'!
prepara: umNome
	"adiciona o ingrediente ao prato"

	Transcript show: 'Robo: recebendo ingrediente [' , umNome , ']';cr.
	ingredientes add: umNome.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Robo class
	instanceVariableNames: ''!

!Robo class methodsFor: 'class initialization' stamp: 'm.d. 4/27/2007 18:28'!
novoComEstilo: umaConstante
	"Instancia um novo robo que cozinha no estilo umEstilo"

	| r |
	r := Robo new.
 	r setEstilo: umaConstante.
	r allocateIngredientes.
	Transcript show: 'Robo inicializado';cr.
	^r.
! !
